## open-adventure 1.4+git20170917.0.d512384

=== Makefile ===
# Makefile for the open-source release of adventure 2.5

# To build with save/resume disabled, pass CCFLAGS="-D ADVENT_NOSAVE"

VERS=$(shell sed -n <NEWS '/^[0-9]/s/:.*//p' | head -1)

.PHONY: debug indent release refresh dist linty html clean
.PHONY: check coverage

CC?=gcc
CCFLAGS+=-std=c99 -D_DEFAULT_SOURCE -DVERSION=\"$(VERS)\" -O2 -D_FORTIFY_SOURCE=2 -fstack-protector-all
LIBS=$(shell pkg-config --libs libedit)
INC+=$(shell pkg-config --cflags libedit)

OBJS=main.o init.o actions.o score.o misc.o saveresume.o
CHEAT_OBJS=cheat.o init.o actions.o score.o misc.o saveresume.o
SOURCES=$(OBJS:.o=.c) advent.h adventure.yaml Makefile control make_dungeon.py templates/*.tpl

.c.o:
	$(CC) $(CCFLAGS) $(INC) $(DBX) -c $<

advent:	$(OBJS) dungeon.o
	$(CC) $(CCFLAGS) $(DBX) -o advent $(OBJS) dungeon.o $(LDFLAGS) $(LIBS)

main.o:	 	advent.h dungeon.h

init.o:	 	advent.h dungeon.h

actions.o:	advent.h dungeon.h

score.o:	advent.h dungeon.h

misc.o:		advent.h dungeon.h

cheat.o:	advent.h dungeon.h

saveresume.o:	advent.h dungeon.h

dungeon.o:	dungeon.c dungeon.h
	$(CC) $(CCFLAGS) $(DBX) -c dungeon.c

dungeon.c dungeon.h: make_dungeon.py adventure.yaml templates/*.tpl
	./make_dungeon.py

clean:
	rm -f *.o advent cheat *.html *.gcno *.gcda
	rm -f dungeon.c dungeon.h
	rm -f README advent.6 MANIFEST *.tar.gz
	rm -f *~
	rm -f .*~
	rm -rf coverage advent.info
	cd tests; $(MAKE) --quiet clean


cheat: $(CHEAT_OBJS) dungeon.o
	$(CC) $(CCFLAGS) $(DBX) -o cheat $(CHEAT_OBJS) dungeon.o $(LDFLAGS) $(LIBS)

check: advent cheat
	cd tests; $(MAKE) --quiet

coverage: debug
	cd tests; $(MAKE) coverage --quiet

.SUFFIXES: .adoc .html .6

# Requires asciidoc and xsltproc/docbook stylesheets.
.adoc.6:
	a2x --doctype manpage --format manpage $<
.adoc.html:
	asciidoc $<
.adoc:
	asciidoc $<

html: advent.html history.html hints.html

# README.adoc exists because that filename is magic on GitLab.
DOCS=COPYING NEWS README.adoc TODO advent.adoc history.adoc notes.adoc hints.adoc advent.6 INSTALL.adoc
TESTFILES=tests/*.log tests/*.chk tests/README tests/decheck tests/Makefile

# Can't use GNU tar's --transform, needs to build under Alpine Linux.
# This is a requirement for testing dist in GitLab's CI pipeline
advent-$(VERS).tar.gz: $(SOURCES) $(DOCS)
	@find $(SOURCES) $(DOCS) $(TESTFILES) -print | sed s:^:advent-$(VERS)/: >MANIFEST
	@(ln -s . advent-$(VERS))
	(tar -T MANIFEST -czvf advent-$(VERS).tar.gz)
	@(rm advent-$(VERS))

indent:
	astyle -n -A3 --pad-header --min-conditional-indent=1 --pad-oper *.c

release: advent-$(VERS).tar.gz advent.html history.html hints.html notes.html
	shipper version=$(VERS) | sh -e -x

refresh: advent.html notes.html history.html
	shipper -N -w version=$(VERS) | sh -e -x

dist: advent-$(VERS).tar.gz

linty: CCFLAGS += -W
linty: CCFLAGS += -Wall
linty: CCFLAGS += -Wextra
linty: CCGLAGS += -Wpedantic
linty: CCFLAGS += -Wundef
linty: CCFLAGS += -Wstrict-prototypes
linty: CCFLAGS += -Wmissing-prototypes
linty: CCFLAGS += -Wmissing-declarations
linty: CCFLAGS += -Wshadow
linty: CCFLAGS += -Wfloat-equal
linty: CCFLAGS += -Wcast-align
linty: CCFLAGS += -Wwrite-strings
linty: CCFLAGS += -Waggregate-return
linty: CCFLAGS += -Wcast-qual
linty: CCFLAGS += -Wswitch-enum
linty: CCFLAGS += -Wwrite-strings
linty: CCFLAGS += -Wunreachable-code
linty: CCFLAGS += -Winit-self
linty: CCFLAGS += -Wpointer-arith
linty: advent cheat

debug: CCFLAGS += -O0
debug: CCFLAGS += --coverage
debug: CCFLAGS += -ggdb
debug: CCFLAGS += -U_FORTIFY_SOURCE
debug: CCFLAGS += -fsanitize=address
debug: CCFLAGS += -fsanitize=undefined
debug: linty

CSUPPRESSIONS = --suppress=missingIncludeSystem --suppress=invalidscanf
cppcheck:
	cppcheck -I. --template gcc --enable=all $(CSUPPRESSIONS) *.[ch]

=== tests/Makefile ===
# Test-suite makefile for reposurgeon

# Use absolute path so tests that change working directory still use
# scripts from parent directory.  Note that using $PWD seems to fail
# here under Gitlab's CI environment.
PARDIR=$(realpath ..)
PATH := $(PARDIR):$(realpath .):${PATH}
GCOV?=gcov

# Make this overrideable so it's easier to test old versions
advent?=advent

# Defeat annoying behavior under Mac OS X - builtin echo doesn't do -n
ECHO := /bin/echo

# Find all *.log entries to test
TESTLOADS := $(shell ls -1 *.log | sed '/.log/s///' | sort)

.PHONY: check coverage clean testlist listcheck savegames buildregress
.PHONY: savecheck regress

check: savecheck regress
	@echo "=== No diff output is good news."
	@-advent -x 2>/dev/null	# Get usage message into coverage tests
	@-advent -l /dev/null <pitfall.log >/dev/null

coverage: check
	lcov -t "advent" -o $(PARDIR)/advent.info -c -d $(PARDIR) --gcov-tool=$(GCOV)
	genhtml -o $(PARDIR)/coverage/ $(PARDIR)/advent.info
	./coverage_dungeon.py

.SUFFIXES: .chk

clean:
	rm -fr *~ adventure.text *.adv scratch.tmp

# Show summary lines for all tests.
testlist:
	@grep '^##' *.log
listcheck:
	@for f in *.log; do \
	    if ( head -3 $$f | grep -q '^ *##' ); then :; else echo "$$f needs a description"; fi; \
	done

# Generate bogus savegames.
savegames:
	@$(ECHO) "cheat: Generate save file with -900 deaths"
	@$(PARDIR)/cheat -d -900 -o cheat_numdie.adv > /tmp/cheat_numdie
	@$(ECHO) "cheat: Generate save file with -1000 deaths"
	@$(PARDIR)/cheat -d -1000 -o cheat_numdie1000.adv > /tmp/cheat_numdie1000
	@$(ECHO) "cheat: Generate save file with version -1337"
	@$(PARDIR)/cheat -v -1337 -o resume_badversion.adv > /tmp/cheat_badversion
	@$(ECHO) "cheat: Generate save file 1000 saves"
	@$(PARDIR)/cheat -s -1000 -o thousand_saves.adv > /tmp/cheat_1000saves
	@$(ECHO) "cheat: Generate save file 1000 turns"
	@$(PARDIR)/cheat -t -1000 -o thousand_saves.adv > /tmp/cheat_1000turns
	@$(ECHO) "cheat: Generate save file 1000 turns"
	@$(PARDIR)/cheat -l -1000 -o thousand_lamp.adv > /tmp/cheat_1000lamp
	@rm -f /tmp/cheat*


# Rebuild characterizing tests
buildregress: savegames
	$(PARDIR)/cheat -s -1000 -o thousand_saves.adv > /tmp/regress1000saves
	@for file in $(TESTLOADS); do \
	    echo "Remaking $${file}.chk"; \
	    OPTS=`sed -n /#options:/s///p <$${file}.log`; \
	    advent $$OPTS <$${file}.log >$${file}.chk 2>&1 || exit 1; \
	done; \
	rm -f scratch.tmp

savecheck: savegames
	@$(ECHO) "TEST cheat: Bogus option for save file generation"
	@$(PARDIR)/cheat -QqQ 2> /tmp/coverage_cheat_batopt | true
	@$(ECHO) "TEST cheat: No save file specified"
	@$(PARDIR)/cheat 2>/dev/null | true
	@$(ECHO) "TEST cheat: Fail to save because we omit -o"
	@$(PARDIR)/cheat -d 1 2> /tmp/coverage_cheat_nooutput | true
	@$(ECHO) "TEST cheat: Fail to save to invalid path"
	@$(PARDIR)/cheat -o / 2> /tmp/coverage_cheat_badoutput | true
	@$(ECHO) "TEST advent: Start with invalid file with -r"
	@advent -r /badfilename < pitfall.log > /tmp/coverage_advent_readfail 2>&1 || exit 1
	@$(ECHO) "TEST advent: Start with invalid file with -l"
	@advent -l / < pitfall.log > /tmp/coverage_advent_logfail 2>&1 || exit 1
	@$(ECHO) "TEST advent: Test -r with valid input"
	@advent -r thousand_saves.adv < pitfall.log > /tmp/coverage_advent_readfail 2>&1 || exit 1
	@rm -f /tmp/coverage*

# General regression testing of commands and output; look at the *.log and
# corresponding *.chk files to see which tests this runs.
regress:
	@for file in $(TESTLOADS); do \
	    $(ECHO) -n "  $${file} "; grep '##' $${file}.log  || echo ' ## (no description)'; \
	    OPTS=`sed -n /#options:/s///p <$${file}.log`; \
	    if $(advent) $$OPTS < $${file}.log >/tmp/regress$$$$ 2>&1; \
	    then diff --text -u $${file}.chk /tmp/regress$$$$ || exit 1; \
	    else echo "*** Nonzero return status on $${file}!"; exit 1; fi \
	done; \
	rm -f scratch.tmp /tmp/regress$$$$

# end

=== debian/changelog ===
open-adventure (1.4+git20170917.0.d512384-2) unstable; urgency=medium

  * Fix FTBFS in Ubuntu.
    The package fails to build in Ubuntu, because the Ubuntu
    autobuilders run with a $TERM value of 'unknown', and the
    open-adventure testsuite doesn't like this. Setting $TERM
    to a known-good value makes the package build more portable.
    Thanks to Steve Langasek <steve.langasek@canonical.com> (Closes: #889519)
  * Switch Vcs-URLs to salsa.d.o
  * Use debhelper v11
  * Update d/copyright
  * Update Standards-Version to 4.1.3, no changes needed
  * Add $(CFLAGS) to package building

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 04 Feb 2018 12:05:18 +0100

open-adventure (1.4+git20170917.0.d512384-1) unstable; urgency=medium

  * New upstream version 1.4+git20170917.0.d512384
    - Fix FTBFS on architectures other than amd64/arm64. Closes: #874205
  * Update Standards-Version to 4.1.1, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 30 Sep 2017 09:10:38 +0200

open-adventure (1.4-1) unstable; urgency=medium

  * New upstream version 1.4
    - Remove advent.desktop and advent.svg, have been included upstream
    - Install .desktop and .svg from upstream
    - Overriding dh_install is no longer necessary
    - Add patch to build package with Python 3
  * Use real homepage, not gitlab
  * Update d/watch to recognize new tarballs
  * Update Standards-Version to 4.1.0

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 03 Sep 2017 20:32:04 +0200

open-adventure (1.2-1) unstable; urgency=medium

  * Initial release (Closes: #868163)

 -- Dr. Tobias Quathamer <toddy@debian.org>  Thu, 13 Jul 2017 14:23:19 +0200

=== debian/control ===
Source: open-adventure
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Dr. Tobias Quathamer <toddy@debian.org>
Build-Depends: debhelper (>= 11), pkg-config, python3-yaml, libedit-dev,
# The following packages are needed to build the manpage advent.6
 asciidoc-base, xsltproc, docbook-xml, docbook-xsl
Standards-Version: 4.1.3
Homepage: http://www.catb.org/~esr/open-adventure/
Vcs-Git: https://salsa.debian.org/games-team/open-adventure.git
Vcs-Browser: https://salsa.debian.org/games-team/open-adventure

Package: open-adventure
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: colossal cave adventure, the 1995 430-point version
 This is the last descendent of the original 1976 Colossal Cave
 Adventure worked on by the original authors -- Crowther & Woods.
 It has sometimes been known as Adventure 2.5. The original PDP-10
 name 'advent' is used for the built program to avoid collision with
 the BSD Games version.

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/(\d\S+)\/archive\.tar\.gz/open-adventure-$1\.tar\.gz/g \
  https://gitlab.com/esr/open-adventure/tags .*/repository/(\d\S+)/archive\.tar\.gz

## open-adventure 1.8

=== Makefile ===
--- 
+++ 
@@ -11,6 +11,12 @@
 CCFLAGS+=-std=c99 -D_DEFAULT_SOURCE -DVERSION=\"$(VERS)\" -O2 -D_FORTIFY_SOURCE=2 -fstack-protector-all
 LIBS=$(shell pkg-config --libs libedit)
 INC+=$(shell pkg-config --cflags libedit)
+
+# LLVM/Clang on macOS seems to need -ledit flag for linking
+UNAME_S := $(shell uname -s)
+ifeq ($(UNAME_S),Darwin)
+    LIBS += -ledit
+endif
 
 OBJS=main.o init.o actions.o score.o misc.o saveresume.o
 CHEAT_OBJS=cheat.o init.o actions.o score.o misc.o saveresume.o
@@ -39,7 +45,7 @@
 dungeon.o:	dungeon.c dungeon.h
 	$(CC) $(CCFLAGS) $(DBX) -c dungeon.c
 
-dungeon.c dungeon.h: make_dungeon.py adventure.yaml templates/*.tpl
+dungeon.c dungeon.h: make_dungeon.py adventure.yaml advent.h templates/*.tpl
 	./make_dungeon.py
 
 clean:
@@ -105,6 +111,8 @@
 linty: CCFLAGS += -Wmissing-prototypes
 linty: CCFLAGS += -Wmissing-declarations
 linty: CCFLAGS += -Wshadow
+linty: CCFLAGS += -Wnull-dereference
+linty: CCFLAGS += -Wjump-misses-init
 linty: CCFLAGS += -Wfloat-equal
 linty: CCFLAGS += -Wcast-align
 linty: CCFLAGS += -Wwrite-strings

=== debian/changelog ===
open-adventure (1.8-1) unstable; urgency=medium

  * New upstream version 1.8
    - Refresh patches
  * Update d/watch for new download location
  * Switch to debhelper-compat and use v12
  * Update d/copyright
  * Update Standards-Version to 4.4.0, no changes needed
  * Apply fixes from cme fix dpkg

 -- Dr. Tobias Quathamer <toddy@debian.org>  Thu, 29 Aug 2019 12:00:34 +0200

=== debian/control ===
Source: open-adventure
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Dr. Tobias Quathamer <toddy@debian.org>
Section: games
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libedit-dev,
               pkg-config,
               python3-yaml,
# The following packages are needed to build the manpage advent.6
               asciidoc-base,
               docbook-xml,
               docbook-xsl,
               xsltproc
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/games-team/open-adventure
Vcs-Git: https://salsa.debian.org/games-team/open-adventure.git
Homepage: http://www.catb.org/~esr/open-adventure/

Package: open-adventure
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: colossal cave adventure, the 1995 430-point version
 This is the last descendent of the original 1976 Colossal Cave
 Adventure worked on by the original authors -- Crowther & Woods.
 It has sometimes been known as Adventure 2.5. The original PDP-10
 name 'advent' is used for the built program to avoid collision with
 the BSD Games version.

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# The package fails to build in Ubuntu, because the Ubuntu
# autobuilders run with a $TERM value of 'unknown', and the
# open-adventure testsuite doesn't like this. Setting $TERM
# to a known-good value makes the package build more portable.
# See https://bugs.debian.org/889519
export TERM=xterm

%:
	dh $@

override_dh_installman:
	make advent.6
	dh_installman

## open-adventure 1.9

=== debian/changelog ===
open-adventure (1.9-1) unstable; urgency=medium

  * New upstream version 1.9
    - Remove patch which has been appled upstream
  * Remove unneeded --as-needed flag :-)
  * Add Rules-Requires-Root: no to d/rules
  * Update Standards-Version to 4.5.1, no changes needed
  * Use debhelper v13

 -- Dr. Tobias Quathamer <toddy@debian.org>  Wed, 09 Dec 2020 13:22:04 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Dr. Tobias Quathamer <toddy@debian.org>
 Section: games
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libedit-dev,
                pkg-config,
                python3-yaml,
@@ -12,7 +12,8 @@
                docbook-xml,
                docbook-xsl,
                xsltproc
-Standards-Version: 4.4.0
+Standards-Version: 4.5.1
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/games-team/open-adventure
 Vcs-Git: https://salsa.debian.org/games-team/open-adventure.git
 Homepage: http://www.catb.org/~esr/open-adventure/

## open-adventure 1.11

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 .PHONY: check coverage
 
 CC?=gcc
-CCFLAGS+=-std=c99 -D_DEFAULT_SOURCE -DVERSION=\"$(VERS)\" -O2 -D_FORTIFY_SOURCE=2 -fstack-protector-all
+CCFLAGS+=-std=c99 -D_DEFAULT_SOURCE -DVERSION=\"$(VERS)\" -O2 -D_FORTIFY_SOURCE=2 -fstack-protector-all $(CFLAGS) -g
 LIBS=$(shell pkg-config --libs libedit)
 INC+=$(shell pkg-config --cflags libedit)
 
@@ -64,6 +64,9 @@
 check: advent cheat
 	cd tests; $(MAKE) --quiet
 
+# After this, run your browser on coverage/open-adventure/index.html
+# to see coverage results. Browse coverage/adventure.yaml.html
+# to see symbol coverage over the YAML file.
 coverage: debug
 	cd tests; $(MAKE) coverage --quiet
 
@@ -133,6 +136,10 @@
 debug: CCFLAGS += -fsanitize=undefined
 debug: linty
 
-CSUPPRESSIONS = --suppress=missingIncludeSystem --suppress=invalidscanf
+PYSUPPRESSIONS = --suppress=missingIncludeSystem --suppress=invalidscanf
 cppcheck:
 	cppcheck -I. --template gcc --enable=all $(CSUPPRESSIONS) *.[ch]
+
+PYSUPPRESSIONS = line-too-long,invalid-name,missing-function-docstring,too-many-lines,too-many-branches,global-statement,multiple-imports,too-many-locals,too-many-statements,too-many-nested-blocks,no-else-return,raise-missing-from,redefined-outer-name,consider-using-in
+pylint:
+	@pylint --score=n --disable=$(PYSUPPRESSIONS) *.py */*.py

=== debian/changelog ===
open-adventure (1.11-1) unstable; urgency=medium

  * New upstream version 1.11
    - Uses yaml.safe_load() in tests. Closes: #1022032
    - Remove patch, has been applied upstream
  * Update d/copyright
  * Update Standards-Version to 4.6.1, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 22 Oct 2022 17:18:25 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                docbook-xml,
                docbook-xsl,
                xsltproc
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/games-team/open-adventure
 Vcs-Git: https://salsa.debian.org/games-team/open-adventure.git

## open-adventure 1.12

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Makefile for the open-source release of adventure 2.5
 
-# To build with save/resume disabled, pass CCFLAGS="-D ADVENT_NOSAVE"
+# To build with save/resume disabled, pass CFLAGS="-DADVENT_NOSAVE"
 
 VERS=$(shell sed -n <NEWS '/^[0-9]/s/:.*//p' | head -1)
 
@@ -83,7 +83,7 @@
 html: advent.html history.html hints.html
 
 # README.adoc exists because that filename is magic on GitLab.
-DOCS=COPYING NEWS README.adoc TODO advent.adoc history.adoc notes.adoc hints.adoc advent.6 INSTALL.adoc
+DOCS=COPYING NEWS README.adoc advent.adoc history.adoc notes.adoc hints.adoc advent.6 INSTALL.adoc
 TESTFILES=tests/*.log tests/*.chk tests/README tests/decheck tests/Makefile
 
 # Can't use GNU tar's --transform, needs to build under Alpine Linux.
@@ -136,10 +136,10 @@
 debug: CCFLAGS += -fsanitize=undefined
 debug: linty
 
-PYSUPPRESSIONS = --suppress=missingIncludeSystem --suppress=invalidscanf
+CSUPPRESSIONS = --suppress=missingIncludeSystem --suppress=invalidscanf
 cppcheck:
 	cppcheck -I. --template gcc --enable=all $(CSUPPRESSIONS) *.[ch]
 
-PYSUPPRESSIONS = line-too-long,invalid-name,missing-function-docstring,too-many-lines,too-many-branches,global-statement,multiple-imports,too-many-locals,too-many-statements,too-many-nested-blocks,no-else-return,raise-missing-from,redefined-outer-name,consider-using-in
+PYSUPPRESSIONS = line-too-long,invalid-name,missing-function-docstring,too-many-lines,too-many-branches,global-statement,multiple-imports,too-many-locals,too-many-statements,too-many-nested-blocks,no-else-return,raise-missing-from,redefined-outer-name,consider-using-in,dict-iter-missing-items
 pylint:
 	@pylint --score=n --disable=$(PYSUPPRESSIONS) *.py */*.py

=== tests/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Test-suite makefile for reposurgeon
+# Test-suite makefile for opeb-adventure
 
 # Use absolute path so tests that change working directory still use
 # scripts from parent directory.  Note that using $PWD seems to fail
@@ -13,21 +13,25 @@
 # Defeat annoying behavior under Mac OS X - builtin echo doesn't do -n
 ECHO := /bin/echo
 
+# The TAP filter. Only affects presentation of the test suite messages
+TAPCONSUMER=tapview
+
+# Fall back to safety if our declared TAP consumer does not exist.
+# This is helpful in the CI environment, where it would be better for
+# the logfiles to carry the raw TAP messages. 
+TAPFILTER=$(shell command -v $(TAPCONSUMER) || echo cat)
+
 # Find all *.log entries to test
 TESTLOADS := $(shell ls -1 *.log | sed '/.log/s///' | sort)
 
-.PHONY: check coverage clean testlist listcheck savegames buildregress
-.PHONY: savecheck regress
+.PHONY: check clean testlist listcheck savegames savecheck coverage
+.PHONY: buildchecks multifile-regress tap count
 
-check: savecheck regress
+check: savecheck
+	@make tap | tapview
 	@echo "=== No diff output is good news."
 	@-advent -x 2>/dev/null	# Get usage message into coverage tests
 	@-advent -l /dev/null <pitfall.log >/dev/null
-
-coverage: check
-	lcov -t "advent" -o $(PARDIR)/advent.info -c -d $(PARDIR) --gcov-tool=$(GCOV)
-	genhtml -o $(PARDIR)/coverage/ $(PARDIR)/advent.info
-	./coverage_dungeon.py
 
 .SUFFIXES: .chk
 
@@ -58,17 +62,7 @@
 	@$(PARDIR)/cheat -l -1000 -o thousand_lamp.adv > /tmp/cheat_1000lamp
 	@rm -f /tmp/cheat*
 
-
-# Rebuild characterizing tests
-buildregress: savegames
-	$(PARDIR)/cheat -s -1000 -o thousand_saves.adv > /tmp/regress1000saves
-	@for file in $(TESTLOADS); do \
-	    echo "Remaking $${file}.chk"; \
-	    OPTS=`sed -n /#options:/s///p <$${file}.log`; \
-	    advent $$OPTS <$${file}.log >$${file}.chk 2>&1 || exit 1; \
-	done; \
-	rm -f scratch.tmp
-
+# Force coverage of cheat edgecases
 savecheck: savegames
 	@$(ECHO) "TEST cheat: Bogus option for save file generation"
 	@$(PARDIR)/cheat -QqQ 2> /tmp/coverage_cheat_batopt | true
@@ -86,16 +80,35 @@
 	@advent -r thousand_saves.adv < pitfall.log > /tmp/coverage_advent_readfail 2>&1 || exit 1
 	@rm -f /tmp/coverage*
 
-# General regression testing of commands and output; look at the *.log and
-# corresponding *.chk files to see which tests this runs.
-regress:
+coverage: check
+	lcov -t "advent" -o $(PARDIR)/advent.info -c -d $(PARDIR) --gcov-tool=$(GCOV)
+	genhtml -o $(PARDIR)/coverage/ $(PARDIR)/advent.info
+	./coverage_dungeon.py
+
+# Rebuild characterizing tests
+buildchecks: savegames
+	$(PARDIR)/cheat -s -1000 -o thousand_saves.adv > /tmp/regress1000saves
 	@for file in $(TESTLOADS); do \
-	    $(ECHO) -n "  $${file} "; grep '##' $${file}.log  || echo ' ## (no description)'; \
+	    echo "Remaking $${file}.chk"; \
 	    OPTS=`sed -n /#options:/s///p <$${file}.log`; \
-	    if $(advent) $$OPTS < $${file}.log >/tmp/regress$$$$ 2>&1; \
-	    then diff --text -u $${file}.chk /tmp/regress$$$$ || exit 1; \
-	    else echo "*** Nonzero return status on $${file}!"; exit 1; fi \
+	    advent $$OPTS <$${file}.log >$${file}.chk 2>&1 || exit 1; \
 	done; \
-	rm -f scratch.tmp /tmp/regress$$$$
+	echo "inven" | advent isofoo.log /dev/stdin >multifile.chk
+	rm -f scratch.tmp
+
+RUN_TARGETS=$(TESTLOADS:%=run-regress-%)
+$(RUN_TARGETS): run-regress-%: %.log
+	@(test=$(<:.log=); legend=$$(sed -n '/^## /s///p' <"$<" 2>/dev/null || echo "(no description)"); \
+	OPTS=`sed -n /#options:/s///p $<`; \
+	$(advent) $$OPTS <$< | tapdiffer "$<: $${legend}" "$${test}.chk")
+
+multifile-regress:
+	@(echo "inven" | advent isofoo.log /dev/stdin) | tapdiffer "multifile: multiple-file test" multifile.chk
+
+TEST_TARGETS = $(RUN_TARGETS) multifile-regress
+
+tap: count $(TEST_TARGETS)
+count:
+	@echo 1..$(words $(TEST_TARGETS))
 
 # end

=== debian/changelog ===
open-adventure (1.12-1) unstable; urgency=medium

  * New upstream version 1.12
    - TODOs have all been done, so don't try to install that file.
  * Update Standards-Version to 4.6.2, no changes needed
  * Update d/copyright

 -- Dr. Tobias Quathamer <toddy@debian.org>  Tue, 28 Feb 2023 13:18:46 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                docbook-xml,
                docbook-xsl,
                xsltproc
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/games-team/open-adventure
 Vcs-Git: https://salsa.debian.org/games-team/open-adventure.git

=== debian/rules ===
--- 
+++ 
@@ -2,9 +2,6 @@
 
 # see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-
-# package maintainers to append LDFLAGS
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 # The package fails to build in Ubuntu, because the Ubuntu
 # autobuilders run with a $TERM value of 'unknown', and the

=== debian/watch ===
version=4
https://gitlab.com/esr/open-adventure/tags .*/archive/(\d\S+)/.*\.tar\.gz

## open-adventure 1.18

=== Makefile ===
--- 
+++ 
@@ -1,14 +1,18 @@
 # Makefile for the open-source release of adventure 2.5
 
+# SPDX-FileCopyrightText: (C) Eric S. Raymond <esr@thyrsus.com>
+# SPDX-License-Identifier: BSD-2-Clause
+
 # To build with save/resume disabled, pass CFLAGS="-DADVENT_NOSAVE"
+# To build with auto-save/resume enabled, pass CFLAGS="-DADVENT_AUTOSAVE"
 
-VERS=$(shell sed -n <NEWS '/^[0-9]/s/:.*//p' | head -1)
+VERS=$(shell sed -n <NEWS.adoc '/^[0-9]/s/:.*//p' | head -1)
 
 .PHONY: debug indent release refresh dist linty html clean
 .PHONY: check coverage
 
 CC?=gcc
-CCFLAGS+=-std=c99 -D_DEFAULT_SOURCE -DVERSION=\"$(VERS)\" -O2 -D_FORTIFY_SOURCE=2 -fstack-protector-all $(CFLAGS) -g
+CCFLAGS+=-std=c99 -D_DEFAULT_SOURCE -DVERSION=\"$(VERS)\" -O2 -D_FORTIFY_SOURCE=2 -fstack-protector-all $(CFLAGS) -g $(EXTRA)
 LIBS=$(shell pkg-config --libs libedit)
 INC+=$(shell pkg-config --cflags libedit)
 
@@ -61,29 +65,43 @@
 cheat: $(CHEAT_OBJS) dungeon.o
 	$(CC) $(CCFLAGS) $(DBX) -o cheat $(CHEAT_OBJS) dungeon.o $(LDFLAGS) $(LIBS)
 
-check: advent cheat
+CSUPPRESSIONS = --suppress=missingIncludeSystem --suppress=invalidscanf
+cppcheck:
+	@-cppcheck -I. --quiet --template gcc -UPROP_SET_SEEN --enable=all $(CSUPPRESSIONS) *.[ch]
+
+pylint:
+	@-pylint --score=n *.py */*.py
+
+check: advent cheat pylint cppcheck
 	cd tests; $(MAKE) --quiet
 
+reflow:
+	@clang-format --style="{IndentWidth: 8, UseTab: ForIndentation}" -i $$(find . -name "*.[ch]")
+	@black --quiet *.py
+
+# Requires gcov, lcov, libasan6, and libubsan1
+# The last two are Ubuntu names, might vary on other distributions.
 # After this, run your browser on coverage/open-adventure/index.html
 # to see coverage results. Browse coverage/adventure.yaml.html
 # to see symbol coverage over the YAML file.
-coverage: debug
+coverage: clean debug
 	cd tests; $(MAKE) coverage --quiet
 
-.SUFFIXES: .adoc .html .6
+# Note: to suppress the footers with timestamps being generated in HTML,
+# we use "-a nofooter".
+# To debug asciidoc problems, you may need to run "xmllint --nonet --noout --valid"
+# on the intermediate XML that throws an error.
+.SUFFIXES: .html .adoc .6
 
-# Requires asciidoc and xsltproc/docbook stylesheets.
 .adoc.6:
-	a2x --doctype manpage --format manpage $<
+	asciidoctor -D. -a nofooter -b manpage $<
 .adoc.html:
-	asciidoc $<
-.adoc:
-	asciidoc $<
+	asciidoctor -D. -a nofooter -a webfonts! $<
 
 html: advent.html history.html hints.html
 
 # README.adoc exists because that filename is magic on GitLab.
-DOCS=COPYING NEWS README.adoc advent.adoc history.adoc notes.adoc hints.adoc advent.6 INSTALL.adoc
+DOCS=COPYING NEWS.adoc README.adoc advent.adoc history.adoc notes.adoc hints.adoc advent.6 INSTALL.adoc
 TESTFILES=tests/*.log tests/*.chk tests/README tests/decheck tests/Makefile
 
 # Can't use GNU tar's --transform, needs to build under Alpine Linux.
@@ -93,9 +111,6 @@
 	@(ln -s . advent-$(VERS))
 	(tar -T MANIFEST -czvf advent-$(VERS).tar.gz)
 	@(rm advent-$(VERS))
-
-indent:
-	astyle -n -A3 --pad-header --min-conditional-indent=1 --pad-oper *.c
 
 release: advent-$(VERS).tar.gz advent.html history.html hints.html notes.html
 	shipper version=$(VERS) | sh -e -x
@@ -128,6 +143,11 @@
 linty: CCFLAGS += -Wpointer-arith
 linty: advent cheat
 
+# These seem to be more modern options for enabling coverage testing.
+# Documenting them here in case a future version bump disables --coverage.
+#debug: CCFLAGS += -ftest-coverage
+#debug: CCFLAGS += -fprofile-arcs
+
 debug: CCFLAGS += -O0
 debug: CCFLAGS += --coverage
 debug: CCFLAGS += -ggdb
@@ -136,10 +156,3 @@
 debug: CCFLAGS += -fsanitize=undefined
 debug: linty
 
-CSUPPRESSIONS = --suppress=missingIncludeSystem --suppress=invalidscanf
-cppcheck:
-	cppcheck -I. --template gcc --enable=all $(CSUPPRESSIONS) *.[ch]
-
-PYSUPPRESSIONS = line-too-long,invalid-name,missing-function-docstring,too-many-lines,too-many-branches,global-statement,multiple-imports,too-many-locals,too-many-statements,too-many-nested-blocks,no-else-return,raise-missing-from,redefined-outer-name,consider-using-in,dict-iter-missing-items
-pylint:
-	@pylint --score=n --disable=$(PYSUPPRESSIONS) *.py */*.py

=== tests/Makefile ===
# Test-suite makefile for open-adventure

# SPDX-FileCopyrightText: Copyright Eric S. Raymond <esr@thyrsus.com>
# SPDX-License-Identifier: BSD-2-Clause

# Use absolute path so tests that change working directory still use
# scripts from parent directory.  Note that using $PWD seems to fail
# here under Gitlab's CI environment.
PARDIR=$(realpath ..)
PATH := $(PARDIR):$(realpath .):${PATH}
GCOV?=gcov

# Make this overrideable so it's easier to test old versions
advent?=advent

# Defeat annoying behavior under Mac OS X - builtin echo doesn't do -n
ECHO := /bin/echo

# The TAP filter. Only affects presentation of the test suite messages
TAPCONSUMER=tapview

# Fall back to safety if our declared TAP consumer does not exist.
# This is helpful in the CI environment, where it would be better for
# the logfiles to carry the raw TAP messages. 
TAPFILTER=$(shell command -v $(TAPCONSUMER) || echo cat)

# Find all *.log entries to test
TESTLOADS := $(shell ls -1 *.log | sed '/.log/s///' | sort)

.PHONY: check clean testlist listcheck savegames savecheck coverage
.PHONY: buildchecks multifile-regress tap count

check: savecheck
	@make tap | tapview
	@-advent -x 2>/dev/null	|| exit 0 # Get usage message into coverage tests

.SUFFIXES: .chk

clean:
	rm -fr *~ *.adv scratch.tmp *.ochk advent430 adventure.data

# Show summary lines for all tests.
testlist:
	@grep '^##' *.log
listcheck:
	@for f in *.log; do \
	    if ( head -3 $$f | grep -q '^ *##' ); then :; else echo "$$f needs a description"; fi; \
	done

# Generate bogus savegames.
cheat_numdie.adv:
	@$(PARDIR)/cheat -d -900 -o cheat_numdie.adv > /tmp/cheat_numdie
cheat_numdie1000.adv:
	@$(PARDIR)/cheat -d -1000 -o cheat_numdie1000.adv > /tmp/cheat_numdie1000
cheat_savetamper.adv:
	@$(PARDIR)/cheat -d 2000 -o cheat_savetamper.adv > /tmp/cheat_savetamper
resume_badversion.adv:
	@$(PARDIR)/cheat -v -1337 -o resume_badversion.adv > /tmp/cheat_badversion
thousand_saves.adv:
	@$(PARDIR)/cheat -s -1000 -o thousand_saves.adv > /tmp/cheat_1000saves
thousand_turns.adv:
	@$(PARDIR)/cheat -t -1000 -o thousand_turns.adv > /tmp/cheat_1000turns
thousand_limit.adv:
	@$(PARDIR)/cheat -l -1000 -o thousand_limit.adv > /tmp/cheat_1000limit
SGAMES = cheat_numdie.adv cheat_numdie1000.adv cheat_savetamper.adv resume_badversion.adv \
	thousand_saves.adv thousand_turns.adv thousand_limit.adv

# Force coverage of cheat edgecases
scheck1:
	@$(PARDIR)/cheat -QqQ 2> /tmp/coverage_cheat_batopt | true
	@./outcheck.sh "cheat: bogus option for save file generation"
scheck2:
	@$(PARDIR)/cheat 2>/dev/null | true
	@./outcheck.sh "cheat: No save file specified"
scheck3:
	@$(PARDIR)/cheat -d 1 2> /tmp/coverage_cheat_nooutput | true
	@./outcheck.sh "cheat: doesn't save because we omit -o"
scheck4:
	@$(PARDIR)/cheat -o / 2> /tmp/coverage_cheat_badoutput | true
	@./outcheck.sh "cheat: doesn't save to invalid path"
scheck5:
	@$(advent) -r /badfilename < pitfall.log > /tmp/coverage_advent_readfail 2>&1 || exit 1
	@./outcheck.sh "cheat: doesn't start with invalid file with -r"
scheck6:
	@$(advent) -l / < pitfall.log > /tmp/coverage_advent_logfail 2>&1 || exit 1
	@./outcheck.sh "cheat: doesn't start with invalid file passed to -l"
scheck7:
	@$(advent) -r thousand_saves.adv < pitfall.log > /tmp/coverage_advent_readfail 2>&1 || exit 1
	@./outcheck.sh "test -r with valid input"
SCHECKS = scheck1 scheck2 scheck3 scheck4 scheck5 scheck6 scheck7

# Don't run this from here, you'll get cryptic warnings and no good result
# if the advent binary wasn't built with coverage flags.  Do "make clean coverage"
# from the top-level directory.
coverage: check
	lcov -t "advent" -o $(PARDIR)/advent.info -c -d $(PARDIR) --gcov-tool=$(GCOV)
	genhtml -o $(PARDIR)/coverage/ $(PARDIR)/advent.info
	./coverage_dungeon.py

# Rebuild characterizing tests
buildchecks: savegames
	$(PARDIR)/cheat -s -1000 -o thousand_saves.adv > /tmp/regress1000saves
	@for file in $(TESTLOADS); do \
	    echo "Remaking $${file}.chk"; \
	    OPTS=`sed -n /#options:/s///p <$${file}.log`; \
	    advent $$OPTS <$${file}.log >$${file}.chk 2>&1 || exit 1; \
	done; \
	echo "inven" | advent issue36.log /dev/stdin >multifile.chk; \
	rm -f scratch.tmp

RUN_TARGETS=$(TESTLOADS:%=run-regress-%)
$(RUN_TARGETS): run-regress-%: %.log
	@(test=$(<:.log=); legend=$$(sed -n '/^## /s///p' <"$<" 2>/dev/null || echo "(no description)"); \
	OPTS=`sed -n /#options:/s///p $<`; \
	$(advent) $$OPTS <$< | tapdiffer "$${test}: $${legend}" "$${test}.chk")

multifile-regress:
	@(echo "inven" | advent issue36.log /dev/stdin) | tapdiffer "multifile: multiple-file test" multifile.chk

TEST_TARGETS = $(SCHECKS) $(RUN_TARGETS) multifile-regress

tap: count $(SGAMES) $(TEST_TARGETS)
	@rm -f scratch.tmp /tmp/coverage* /tmp/cheat*
count:
	@echo 1..$(words $(TEST_TARGETS))

# The following machinery tests the game against a binary made from
# the advent430 branch To use it, switch to that branch, build the
# binary, run it once to generate adventure.data, then switch back to
# master leaving advent430 and adventure.data in place (make clean
# does not remove them).
#
# make clean                 # Clean up object files, laving a bare source tree
# git checkout advent430     # Check out the advent430 branch
# make                       # Build the advent430 binary
# advent430                  # Run it.  Answer the novice question and quit
# make clean                 # Remove .o files
# git checkout master        # Go back to master branch
# make                       # Rebuild advent.
#
# The diff file produced has corrected spellings in it. That's what oldfilter
# is for, to massage out the original spellings and avoid noise diffs.
# Diffs in amount of whitespace and trailing whitespace are ignored
#
# A magic comment of NOCOMPARE in a log file excludes it from this comparison.
# making it a skipped test in the TAP view. First use of this was to avoid a
# spurious mismatch on the news text. Other uses avoid spurious mismatches due
# to bug fixes.
#
# When adding more tests, bear in mind that any game that continues after a
# resurrection will need a NOCOMPARE. At some point in the forward port,
# resurrection was accidentally changed in a way that messed with the LCG chain.
#
# The *.chk files need not be up-to-date for this to work.
#
TAPFILTER=tapview
oldcompare:
	@if [ -f ../advent430 ]; then cp ../advent430 ../adventure.data .; else echo "advent430 nonexistent"; exit 1; fi
	@-(for x in *.log; do \
		stem=$${x%.log}; \
		legend=$$(sed -n '/^## /s///p' <$$x 2>/dev/null || echo "(no description)"); \
		if grep NOCOMPARE $$x >/dev/null; \
			then echo "not ok - $${stem}.ochk: $${legend} # SKIP"; \
			else \
				./advent430 <$${stem}.log | oldfilter >$${stem}.ochk; \
				../advent <$${stem}.log >$${stem}.log-new; \
				./newfilter <$${stem}.log-new | tapdiffer -b "$${stem}: $${legend}" $${stem}.ochk; \
			fi; \
	done; \
	echo 1..$(words $(shell ls *.log))) | $(TAPFILTER)
	@rm *.ochk *-new advent430 adventure.data

# List all NOMPARE tests.
residuals:
	@grep -n NOCOMPARE *.log

# end

=== debian/changelog ===
open-adventure (1.18-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
    Changes-By: lintian-brush
    Fixes: lintian: upstream-metadata-file-is-missing
    See-also: https://lintian.debian.org/tags/upstream-metadata-file-is-missing.html
    Fixes: lintian: upstream-metadata-missing-bug-tracking
    See-also: https://lintian.debian.org/tags/upstream-metadata-missing-bug-tracking.html
  * Update standards version to 4.6.2, no changes needed.
    Changes-By: lintian-brush
    Fixes: lintian: out-of-date-standards-version
    See-also: https://lintian.debian.org/tags/out-of-date-standards-version.html

  [ Dr. Tobias Quathamer ]
  * New upstream version 1.18. Closes: #1071865
  * Rename development branch to debian/latest
  * Update d/watch for new GitLab tag order
  * Update d/copyright
  * Update Standards-Version to 4.7.0, no changes needed
  * Install NEWS.adoc after filename change
  * Use wrap-and-sort -a
  * Clean up Build-Depends

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 26 May 2024 16:28:49 +0200

=== debian/control ===
Source: open-adventure
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Dr. Tobias Quathamer <toddy@debian.org>
Section: games
Priority: optional
Build-Depends:
               debhelper-compat (= 13),
               libedit-dev,
               pkg-config,
               python3-yaml,
# The following package is needed to build the manpage advent.6
               asciidoctor
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/games-team/open-adventure
Vcs-Git: https://salsa.debian.org/games-team/open-adventure.git
Homepage: http://www.catb.org/~esr/open-adventure/

Package: open-adventure
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: colossal cave adventure, the 1995 430-point version
 This is the last descendent of the original 1976 Colossal Cave
 Adventure worked on by the original authors -- Crowther & Woods.
 It has sometimes been known as Adventure 2.5. The original PDP-10
 name 'advent' is used for the built program to avoid collision with
 the BSD Games version.

## open-adventure 1.20

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 .PHONY: check coverage
 
 CC?=gcc
-CCFLAGS+=-std=c99 -D_DEFAULT_SOURCE -DVERSION=\"$(VERS)\" -O2 -D_FORTIFY_SOURCE=2 -fstack-protector-all $(CFLAGS) -g $(EXTRA)
+CCFLAGS+=-std=c99 -Wall -Wextra -D_DEFAULT_SOURCE -DVERSION=\"$(VERS)\" -O2 -D_FORTIFY_SOURCE=2 -fstack-protector-all $(CFLAGS) -g $(EXTRA)
 LIBS=$(shell pkg-config --libs libedit)
 INC+=$(shell pkg-config --cflags libedit)
 
@@ -67,7 +67,7 @@
 
 CSUPPRESSIONS = --suppress=missingIncludeSystem --suppress=invalidscanf
 cppcheck:
-	@-cppcheck -I. --quiet --template gcc -UPROP_SET_SEEN --enable=all $(CSUPPRESSIONS) *.[ch]
+	@-cppcheck -I. --quiet --template gcc -UOBJECT_SET_SEEN --enable=all $(CSUPPRESSIONS) *.[ch]
 
 pylint:
 	@-pylint --score=n *.py */*.py

=== tests/Makefile ===
--- 
+++ 
@@ -170,7 +170,7 @@
 	echo 1..$(words $(shell ls *.log))) | $(TAPFILTER)
 	@rm *.ochk *-new advent430 adventure.data
 
-# List all NOMPARE tests.
+# List all NOCOMPARE tests.
 residuals:
 	@grep -n NOCOMPARE *.log

=== debian/changelog ===
open-adventure (1.20-1) unstable; urgency=medium

  * New upstream version 1.20
  * Build-Depend on pkgconf instead of pkg-config

 -- Dr. Tobias Quathamer <toddy@debian.org>  Fri, 06 Dec 2024 17:17:13 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends:
                debhelper-compat (= 13),
                libedit-dev,
-               pkg-config,
+               pkgconf,
                python3-yaml,
 # The following package is needed to build the manpage advent.6
                asciidoctor

=== debian/watch ===
version=4
opts="searchmode=plain" \
 https://gitlab.com/esr/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
